/*
  File autogenerated by gengetopt version 2.12.1
  generated with the following command:
  gengetopt --input=s_bootstrap_cmd.ggo --file-name=s_bootstrap_cmd --unamed-opts 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "s_bootstrap_cmd.h"

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->verbosity_given = 0 ;
  args_info->format_given = 0 ;
  args_info->numout_given = 0 ;
  args_info->draw_given = 0 ;
  args_info->site_given = 0 ;
  args_info->sample_given = 0 ;
  args_info->out_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->verbosity_arg = 0 ;
  args_info->format_arg = gengetopt_strdup ("xyz");
  args_info->numout_arg = 1 ;
  args_info->draw_arg = 1000 ;
  args_info->out_arg = NULL;
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n"
  "Purpose:\n"
  "  Provide bootstrap resampling of groups of samples.\n"
  "\n"
  "Usage: %s [OPTIONS]... [FILES]...\n", CMDLINE_PARSER_PACKAGE);
  printf("\n");
  printf("%s\n","  -h, --help           Print help and exit");
  printf("%s\n","  -V, --version        Print version and exit");
  printf("%s\n","  -v, --verbosity=INT  Set the verbosity level (0=quiet 10=verbose 20=\n                         bombastic)  (default=`0')");
  printf("%s\n","  -f, --format=STRING  Output format.\n                           s - 7 number s values (see s_eigs)\n                           tpr - polar\n                           xyz - cartesian  (default=`xyz')");
  printf("%s\n","  -n, --numout=INT     Number of output files.\n                           1 - put min, int, max in a single file\n                           3 - put min, int, max each in a separate file.  \n                         Appends the number to the filename.  (default=`1')");
  printf("%s\n","  -d, --draw=INT       How many samples to draw/bootstrap from a particular \n                         file  (default=`1000')");
  printf("%s\n","  -P, --site           Site parametric error using Hext method for sigma");
  printf("%s\n","  -p, --sample         Sample parametric using the per sample sigma (default)");
  printf("%s\n","  -o, --out=filename   Output file name.  If 3 is selected for numout, then a \n                         number will be appended to the filenames");
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);

  args_info->inputs = NULL;
  args_info->inputs_num = 0;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  
  int i;
  if (args_info->format_arg)
    {
      free (args_info->format_arg); /* free previous argument */
      args_info->format_arg = 0;
    }
  if (args_info->out_arg)
    {
      free (args_info->out_arg); /* free previous argument */
      args_info->out_arg = 0;
    }
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);
  
  if (args_info->inputs_num)
    free (args_info->inputs);
  
  clear_given (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;
  
  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);
  
  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */
  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "verbosity",	1, NULL, 'v' },
        { "format",	1, NULL, 'f' },
        { "numout",	1, NULL, 'n' },
        { "draw",	1, NULL, 'd' },
        { "site",	0, NULL, 'P' },
        { "sample",	0, NULL, 'p' },
        { "out",	1, NULL, 'o' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVv:f:n:d:Ppo:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          cmdline_parser_print_version ();
          exit (EXIT_SUCCESS);

        case 'v':	/* Set the verbosity level (0=quiet 10=verbose 20=bombastic).  */
          if (local_args_info.verbosity_given)
            {
              fprintf (stderr, "%s: `--verbosity' (`-v') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->verbosity_given && ! override)
            continue;
          local_args_info.verbosity_given = 1;
          args_info->verbosity_given = 1;
          args_info->verbosity_arg = strtol (optarg,&stop_char,0);
          break;

        case 'f':	/* Output format.\n  s - 7 number s values (see s_eigs)\n  tpr - polar\n  xyz - cartesian.  */
          if (local_args_info.format_given)
            {
              fprintf (stderr, "%s: `--format' (`-f') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->format_given && ! override)
            continue;
          local_args_info.format_given = 1;
          args_info->format_given = 1;
          if (args_info->format_arg)
            free (args_info->format_arg); /* free previous string */
          args_info->format_arg = gengetopt_strdup (optarg);
          break;

        case 'n':	/* Number of output files.\n  1 - put min, int, max in a single file\n  3 - put min, int, max each in a separate file.  Appends the number to the filename..  */
          if (local_args_info.numout_given)
            {
              fprintf (stderr, "%s: `--numout' (`-n') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->numout_given && ! override)
            continue;
          local_args_info.numout_given = 1;
          args_info->numout_given = 1;
          args_info->numout_arg = strtol (optarg,&stop_char,0);
          break;

        case 'd':	/* How many samples to draw/bootstrap from a particular file.  */
          if (local_args_info.draw_given)
            {
              fprintf (stderr, "%s: `--draw' (`-d') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->draw_given && ! override)
            continue;
          local_args_info.draw_given = 1;
          args_info->draw_given = 1;
          args_info->draw_arg = strtol (optarg,&stop_char,0);
          break;

        case 'P':	/* Site parametric error using Hext method for sigma.  */
          if (local_args_info.site_given)
            {
              fprintf (stderr, "%s: `--site' (`-P') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->site_given && ! override)
            continue;
          local_args_info.site_given = 1;
          args_info->site_given = 1;
          break;

        case 'p':	/* Sample parametric using the per sample sigma (default).  */
          if (local_args_info.sample_given)
            {
              fprintf (stderr, "%s: `--sample' (`-p') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->sample_given && ! override)
            continue;
          local_args_info.sample_given = 1;
          args_info->sample_given = 1;
          break;

        case 'o':	/* Output file name.  If 3 is selected for numout, then a number will be appended to the filenames.  */
          if (local_args_info.out_given)
            {
              fprintf (stderr, "%s: `--out' (`-o') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->out_given && ! override)
            continue;
          local_args_info.out_given = 1;
          args_info->out_given = 1;
          if (args_info->out_arg)
            free (args_info->out_arg); /* free previous string */
          args_info->out_arg = gengetopt_strdup (optarg);
          break;


        case 0:	/* Long option with no short option */

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */



  if (check_required)
    {
      if (! args_info->out_given)
        {
          fprintf (stderr, "%s: '--out' ('-o') option required%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
          error = 1;
        }
    }

  if ( error )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;
  
      args_info->inputs_num = argc - optind ;
      args_info->inputs = 
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ; 
    }
  
  return 0;

failure:
  cmdline_parser_free (&local_args_info);
  return (EXIT_FAILURE);
}
